local mod = ...

--[[

    A v2 rework of this mechanic with a slightly more complex setup

]]--



-- Assets
mod:registerAssetId("models/Poultry1.fbx/Prefab/ChickenFlockPart1", "PREFAB_POULTRY_CHICKEN_FLOCK")
mod:registerAssetId("models/Poultry1.fbx/Prefab/ChickenHousePart1", "PREFAB_POULTRY_CHICKENHOUSE")
mod:registerAssetId("models/Poultry1.fbx/Prefab/StumpAxePart", "PREFAB_POULTRY_STUMPAXE")
mod:registerAssetId("models/Poultry1.fbx/Prefab/GoosePenPart", "PREFAB_POULTRY_GOOSEPEN")
mod:registerAssetId("models/Poultry1.fbx/Prefab/ResourcePoultryPart", "PREFAB_POULTRY_RESOURCE_POULTRY")
mod:registerAssetId("models/Poultry1.fbx/Prefab/ResourceEggPart", "PREFAB_POULTRY_RESOURCE_EGGS")


for i=1, 8, 1 do

    -- Grounding
    mod:registerPrefabComponent("models/Poultry1.fbx/Prefab/GoosePenPart/Fence." .. string.sub("000" .. i, -3), { DataType = "COMP_GROUNDED" } )

end


for i=1, 10, 1 do

    -- Register
    mod:registerAssetId("models/Poultry1.fbx/Prefab/ChickenPart." .. string.sub("000" .. i, -3), "PREFAB_CHICKEN_" .. string.sub("000" .. i, -3))
    mod:registerAssetId("models/Poultry1.fbx/Prefab/GoosePart." .. string.sub("000" .. i, -3), "PREFAB_GOOSE_" .. string.sub("000" .. i, -3))

    -- Grounding
    -- these following two lines were causing levitating poultry when the game reloaded
    -- mod:registerPrefabComponent("models/Poultry1.fbx/Prefab/ChickenFlockPart1/Attach_Minor." .. string.sub("000" .. i, -3), { DataType = "COMP_GROUNDED" } )
    -- mod:registerPrefabComponent("models/Poultry1.fbx/Prefab/ChickenPart." .. string.sub("000" .. i, -3) .. "/Attach_Minor." .. string.sub("000" .. i+10, -3), { DataType = "COMP_GROUNDED" })
    mod:registerPrefabComponent("models/Poultry1.fbx/Prefab/ChickenPart." .. string.sub("000" .. i, -3), { DataType = "COMP_GROUNDED" })
    mod:registerPrefabComponent("models/Poultry1.fbx/Prefab/GoosePart." .. string.sub("000" .. i, -3), { DataType = "COMP_GROUNDED" })

    -- Attach Type
    mod:registerPrefabComponent("models/Poultry1.fbx/Prefab/ChickenPart." .. string.sub("000" .. i, -3), { DataType = "COMP_BUILDING_PART", BuildingPartType = "MINOR" })
    mod:registerPrefabComponent("models/Poultry1.fbx/Prefab/GoosePart." .. string.sub("000" .. i, -3), { DataType = "COMP_BUILDING_PART", BuildingPartType = "MINOR" })

    -- Resource container
    mod:registerPrefabComponent( "models/Poultry1.fbx/Prefab/ChickenPart." .. string.sub("000" .. i, -3) .. "/Chicken." .. string.sub("000" .. i, -3), {
        DataType = "COMP_RESOURCE_CONTAINER",
        ResourceData = "RESOURCE_CHICKEN",
        IsReplenishable = true,
        ReplenishDurationInDays = 28,
        ReplenishQuantity = 1,
        ResourceValue = 1.0, -- how many are gathered with each pick
        AvailableQuantity = 1, -- maximum container stock
        Radius = 1.25, -- distance from container that the villager will stand to pick
        ReplenishedMaterial = "MATERIAL_POULTRY_COLOR",
        DepletedMaterial = "MATERIAL_POULTRY_TRANSPARENT",
        IsDestroyWhenEmpty = false
    })

    mod:registerPrefabComponent( "models/Poultry1.fbx/Prefab/GoosePart." .. string.sub("000" .. i, -3) .. "/Goose." .. string.sub("000" .. i, -3), {
        DataType = "COMP_RESOURCE_CONTAINER",
        ResourceData = "RESOURCE_GOOSE",
        IsReplenishable = true,
        ReplenishDurationInDays = 28,
        ReplenishQuantity = 1,
        ResourceValue = 1.0, -- how many are gathered with each pick
        AvailableQuantity = 1, -- maximum container stock
        Radius = 1.25, -- distance from container that the villager will stand to pick
        ReplenishedMaterial = "MATERIAL_POULTRY_COLOR",
        DepletedMaterial = "MATERIAL_POULTRY_TRANSPARENT",
        IsDestroyWhenEmpty = false
    })

end



-- Building Asset Processor
mod:registerAssetProcessor("models/Poultry1.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })



-- Material -------------------------------------------------------------------------------------
mod:registerAssetId("models/Poultry1.fbx/Materials/Material.Colour", "MATERIAL_POULTRY_COLOR")
mod:registerAssetId("models/Poultry1.fbx/Materials/Material.Transparent", "MATERIAL_POULTRY_TRANSPARENT")
mod:override({
    Id = "MATERIAL_POULTRY_TRANSPARENT",
    HasAlphaTest = true
})



-- Resource: Chicken -------------------------------------------------------------------------------------
-- mod:registerAssetId("icons/Chicken.png", "ICON_CHICKEN")

-- mod:register({
-- 	DataType = "RESOURCE",
-- 	Id = "RESOURCE_CHICKEN",
-- 	ResourceName = "RESOURCE_CHICKEN_NAME",
-- 	Icon = "ICON_CHICKEN",
-- 	ResourceTypeList = { "RESOURCE_FOOD" },
-- 	IsTradable = false,
-- 	ResourceLayoutType = "CRATES",
-- 	DisplayInInventory = false
-- })



-- Resource: Goose -------------------------------------------------------------------------------------
-- mod:registerAssetId("icons/Goose.png", "ICON_GOOSE")

-- mod:register({
-- 	DataType = "RESOURCE",
-- 	Id = "RESOURCE_GOOSE",
-- 	ResourceName = "RESOURCE_GOOSE_NAME",
-- 	Icon = "ICON_GOOSE",
-- 	ResourceTypeList = { "RESOURCE_FOOD" },
-- 	IsTradable = false,
-- 	ResourceLayoutType = "CRATES",
-- 	DisplayInInventory = false
-- })



-- Resource: Eggs (Override) -------------------------------------------------------------------------------------
mod:override({
    Id = "BV1_EGG",
    ResourceVisualPrefab = "PREFAB_POULTRY_RESOURCE_EGGS"
})



-- Job: Slaughter -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_POULTRY_SLAUGHTER",
	JobName = "JOB_POULTRY_NAME",
	JobDescription = "JOB_POULTRY_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_GATHER",
    ProductionDelay = 25, -- default 30
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
			RightHandObject = {
				Model = "PREFAB_TOOL_CARPENTER_AXE"
			},
		IdleAnimation = "IDLE"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_POULTRY_SLAUGHTER"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_POULTRY_SLAUGHTER"
    }
})


-- Job: Gather Eggs -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_POULTRY_EGGS",
	JobName = "JOB_POULTRY_NAME",
	JobDescription = "JOB_POULTRY_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_GATHER",
    ProductionDelay = 25, -- default 30
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
        LeftHandObject = {
            Model = "PREFAB_TOOL_DAIRY_FARMER_BUCKET"
        },
		IdleAnimation = "IDLE"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_POULTRY_EGGS"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_POULTRY_EGGS"
    }
})



-- Job: Gather Eggs and Slaughter -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_POULTRY_COMBINE",
	JobName = "JOB_POULTRY_NAME",
	JobDescription = "JOB_POULTRY_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_GATHER",
    ProductionDelay = 50, -- default 30
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
        LeftHandObject = {
            Model = "PREFAB_TOOL_DAIRY_FARMER_BUCKET"
        },
        RightHandObject = {
            Model = "PREFAB_TOOL_CARPENTER_AXE"
        },
		IdleAnimation = "IDLE"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_POULTRY_COMBINE"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_POULTRY_COMBINE"
    }
})



-- Building Function: Chickens -> Poultry Meat -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_POULTRY_CHICKEN_SLAUGHTER",
    Name = "BUILDING_FUNCTION_POULTRY_CHICKEN_SLAUGHTER_NAME",
    WorkerCapacity = 2,
    RelatedJob = { 
        Job = "JOB_POULTRY_SLAUGHTER", 
        Behavior = "BEHAVIOR_GATHER"
    },
    UpkeepPerCapacity = {
		{ Resource = "GOLD_COINS", Quantity = 2 },
    },
    InputInventoryCapacity = {
		{ Resource = "RESOURCE_CHICKEN", Quantity = 1 },
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_CHICKEN", Quantity = 1 },
	},
    ResourceProduced = {
		{ Resource = "RESOURCE_POULTRY", Quantity = 1 },
		{ Resource = "RESOURCE_DUNG", Quantity = 1 },
	}
})



-- Building Function: Chickens -> Eggs -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_POULTRY_CHICKEN_EGGS",
    Name = "BUILDING_FUNCTION_POULTRY_CHICKEN_EGGS_NAME",
    WorkerCapacity = 2,
    RelatedJob = { 
        Job = "JOB_POULTRY_EGGS", 
        Behavior = "BEHAVIOR_GATHER"
    },
    UpkeepPerCapacity = {
		{ Resource = "GOLD_COINS", Quantity = 2 },
    },
    InputInventoryCapacity = {
		{ Resource = "RESOURCE_CHICKEN", Quantity = 1 },
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_CHICKEN", Quantity = 1 },
	},
    ResourceProduced = {
		{ Resource = "BV1_EGG", Quantity = 2 },
		{ Resource = "RESOURCE_DUNG", Quantity = 1 },
	}
})



-- Building Function: Chickens -> Poultry and Eggs -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_POULTRY_CHICKEN_COMBINE",
    Name = "BUILDING_FUNCTION_POULTRY_CHICKEN_COMBINE_NAME",
    WorkerCapacity = 2,
    RelatedJob = { 
        Job = "JOB_POULTRY_COMBINE", 
        Behavior = "BEHAVIOR_GATHER"
    },
    UpkeepPerCapacity = {
		{ Resource = "GOLD_COINS", Quantity = 2 },
    },
    InputInventoryCapacity = {
		{ Resource = "RESOURCE_CHICKEN", Quantity = 1 },
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_CHICKEN", Quantity = 1 },
	},
    ResourceProduced = {
		{ Resource = "RESOURCE_POULTRY", Quantity = 1 },
		{ Resource = "BV1_EGG", Quantity = 2 },
		{ Resource = "RESOURCE_DUNG", Quantity = 2 },
	}
})



-- Building Function: Geese -> Poultry Meat -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_POULTRY_GOOSE_SLAUGHTER",
    Name = "BUILDING_FUNCTION_POULTRY_GOOSE_SLAUGHTER_NAME",
    WorkerCapacity = 2,
    RelatedJob = { 
        Job = "JOB_POULTRY_SLAUGHTER", 
        Behavior = "BEHAVIOR_GATHER"
    },
    UpkeepPerCapacity = {
		{ Resource = "GOLD_COINS", Quantity = 2 },
    },
    InputInventoryCapacity = {
		{ Resource = "RESOURCE_GOOSE", Quantity = 1 },
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_GOOSE", Quantity = 1 },
	},
    ResourceProduced = {
		{ Resource = "RESOURCE_POULTRY", Quantity = 2 },
		{ Resource = "RESOURCE_DUNG", Quantity = 1 },
	}
})



-- Building Function: Geese -> Eggs -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_POULTRY_GOOSE_EGGS",
    Name = "BUILDING_FUNCTION_POULTRY_GOOSE_EGGS_NAME",
    WorkerCapacity = 2,
    RelatedJob = { 
        Job = "JOB_POULTRY_EGGS", 
        Behavior = "BEHAVIOR_GATHER"
    },
    UpkeepPerCapacity = {
		{ Resource = "GOLD_COINS", Quantity = 2 },
    },
    InputInventoryCapacity = {
		{ Resource = "RESOURCE_GOOSE", Quantity = 1 },
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_GOOSE", Quantity = 1 },
	},
    ResourceProduced = {
		{ Resource = "BV1_EGG", Quantity = 1 },
		{ Resource = "RESOURCE_DUNG", Quantity = 1 },
	}
})



-- Building Function: Geese -> Poultry and Eggs -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_POULTRY_GOOSE_COMBINE",
    Name = "BUILDING_FUNCTION_POULTRY_GOOSE_COMBINE_NAME",
    WorkerCapacity = 2,
    RelatedJob = { 
        Job = "JOB_POULTRY_COMBINE", 
        Behavior = "BEHAVIOR_GATHER"
    },
    UpkeepPerCapacity = {
		{ Resource = "GOLD_COINS", Quantity = 2 },
    },
    InputInventoryCapacity = {
		{ Resource = "RESOURCE_GOOSE", Quantity = 1 },
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_GOOSE", Quantity = 1 },
	},
    ResourceProduced = {
		{ Resource = "RESOURCE_POULTRY", Quantity = 2 },
		{ Resource = "BV1_EGG", Quantity = 1 },
		{ Resource = "RESOURCE_DUNG", Quantity = 2 },
	}
})



-- Building Function Assignable: Chicken -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_ASSIGNABLE",
    Id = "BUILDING_FUNCTION_ASSIGNABLE_POULTRY_CHICKEN",
	Name = "BUILDING_FUNCTION_ASSIGNABLE_POULTRY_CHICKEN_NAME",
	AuthorizedFunctionList = "BUILDING_FUNCTION_LIST_POULTRY_CHICKEN"
})



-- Building Function List: Chicken -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_LIST",
    Id = "BUILDING_FUNCTION_LIST_POULTRY_CHICKEN",
	AssetFunctionList = {
        "BUILDING_FUNCTION_POULTRY_CHICKEN_COMBINE",
		"BUILDING_FUNCTION_POULTRY_CHICKEN_SLAUGHTER",
        "BUILDING_FUNCTION_POULTRY_CHICKEN_EGGS",
	}
})



-- Building Function Assignable: Goose -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_ASSIGNABLE",
    Id = "BUILDING_FUNCTION_ASSIGNABLE_POULTRY_GOOSE",
	Name = "BUILDING_FUNCTION_ASSIGNABLE_POULTRY_GOOSE_NAME",
	AuthorizedFunctionList = "BUILDING_FUNCTION_LIST_POULTRY_GOOSE"
})



-- Building Function List: Goose -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_LIST",
    Id = "BUILDING_FUNCTION_LIST_POULTRY_GOOSE",
	AssetFunctionList = {
        "BUILDING_FUNCTION_POULTRY_GOOSE_COMBINE",
		"BUILDING_FUNCTION_POULTRY_GOOSE_SLAUGHTER",
        "BUILDING_FUNCTION_POULTRY_GOOSE_EGGS",
	}
})



-- Building: Poultry farm -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING", 
	Id = "BUILDING_POULTRY",
	Name = "BUILDING_POULTRY_NAME",
	Description = "CHICKENYARD_DESC",
	BuildingType = "GENERAL",
	AssetCoreBuildingPart = "BUILDING_PART_MONUMENT_POLE",
	BuildingPartSetList = {
		{
			Name = "BUILDING_SET_POULTRY_1",
			BuildingPartList = { 
                "BUILDING_PART_POULTRY_CHICKEN_FLOCK",
                "BUILDING_PART_POULTRY_CHICKEN_RANDOM",
                "BUILDING_PART_POULTRY_CHICKENHOUSE",
            }
        }, 
		{
			Name = "GOOSEPEN_SET_NAME",
			BuildingPartList = { 
                "BUILDING_PART_POULTRY_GOOSE_FLOCK",
                "BUILDING_PART_POULTRY_GOOSE_RANDOM",
                "BUILDING_PART_POULTRY_GOOSEPEN",
            }
        }, 
		{
			Name = "DOVECOTE_SET_NAME",
			BuildingPartList = { 
				"DOVECOTE1_PART",
				"DOVECOTE2_PART",
				"DOVECOTE3_PART",
			}
		}, 
		{
			Name = "MARKET_SET_NAME",
			BuildingPartList = { 
				"POULTRYCART_PART",
				"POULTRYCART_EGG_PART",
			}
		},
	},	
	RequiredPartList = {
		-- { Category = "CORE", Quantity = 1 }
	},
	IsEditable = true
})



-- Building Part: Chicken Flock -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_POULTRY_CHICKEN_FLOCK",
	Name = "BUILDING_PART_POULTRY_CHICKEN_FLOCK_NAME", 
	Description = "BUILDING_PART_POULTRY_CHICKEN_FLOCK_DESC", 
	-- Category = "CORE", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { "PREFAB_POULTRY_CHICKEN_FLOCK" },
		MandatoryBuildingPartList = {
			{ BuildingPart = "BUILDING_PART_POULTRY_CHICKEN_001" },
			{ BuildingPart = "BUILDING_PART_POULTRY_CHICKEN_002" },
			{ BuildingPart = "BUILDING_PART_POULTRY_CHICKEN_003" },
			{ BuildingPart = "BUILDING_PART_POULTRY_CHICKEN_004" },
			{ BuildingPart = "BUILDING_PART_POULTRY_CHICKEN_005" },
			{ BuildingPart = "BUILDING_PART_POULTRY_CHICKEN_006" },
			{ BuildingPart = "BUILDING_PART_POULTRY_CHICKEN_007" },
			{ BuildingPart = "BUILDING_PART_POULTRY_CHICKEN_008" },
			{ BuildingPart = "BUILDING_PART_POULTRY_CHICKEN_009" },
			{ BuildingPart = "BUILDING_PART_POULTRY_CHICKEN_010" },
		}
	},
	-- ConstructionVisual = "PREFAB_CONSTR_CHICKENYARD1",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 2, {0.0, 0.0}, 16 ),
                Type = { DEFAULT = false, NAVIGABLE = true, GRASS_CLEAR = true } 
			}
		}
	},
	Cost = {
        BuildRightTaxes = {	{ Resource = "GOLD_COINS", Quantity = 10 } },
        -- UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 2 } }
	}
})



-- Building Part: individual Chickens -------------------------------------------------------------------------------------
for i=1, 10, 1 do

    mod:register({
        DataType = "BUILDING_PART",
        Id = "BUILDING_PART_POULTRY_CHICKEN_" .. string.sub("000" .. i, -3),
        Name = "BUILDING_PART_POULTRY_CHICKEN_" .. string.sub("000" .. i, -3) .. "_NAME", 
        ConstructorData = {
            DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
            CoreObjectPrefab = "PREFAB_CHICKEN_" .. string.sub("000" .. i, -3)
        }
    })

end



-- Building Part: One Chicken (Random) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_POULTRY_CHICKEN_RANDOM",
	Name = "BUILDING_PART_POULTRY_CHICKEN_RANDOM_NAME", 
	Description = "BUILDING_PART_POULTRY_CHICKEN_RANDOM_DESC", 
	-- Category = "CORE", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		RandomPartList = {
			"BUILDING_PART_POULTRY_CHICKEN_001",
			"BUILDING_PART_POULTRY_CHICKEN_002",
			"BUILDING_PART_POULTRY_CHICKEN_003",
			"BUILDING_PART_POULTRY_CHICKEN_004",
			"BUILDING_PART_POULTRY_CHICKEN_005",
			"BUILDING_PART_POULTRY_CHICKEN_006",
			"BUILDING_PART_POULTRY_CHICKEN_007",
			"BUILDING_PART_POULTRY_CHICKEN_008",
			"BUILDING_PART_POULTRY_CHICKEN_009",
			"BUILDING_PART_POULTRY_CHICKEN_010",
		}
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 0.25, {0.0, 0.0}, 4 ),
                Type = { DEFAULT = false, NAVIGABLE = true, GRASS_CLEAR = true } 
			}
		}
	},
	Cost = {
        BuildRightTaxes = {	{ Resource = "GOLD_COINS", Quantity = 1 } },
        -- UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 2 } }
	}
})


-- Building Part: Chicken House -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_POULTRY_CHICKENHOUSE",
	Name = "BUILDING_PART_POULTRY_CHICKENHOUSE_NAME", 
	Description = "BUILDING_PART_POULTRY_CHICKENHOUSE_DESC", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_POULTRY_CHICKENHOUSE"
	},
	-- ConstructionVisual = "PREFAB_CONSTR_CHICKENYARD2",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {2.65, 2.90}, {0.0, 1.5} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_ASSIGNABLE_POULTRY_CHICKEN",
	Cost = {
        UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 1 } },
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 4 },
		}
	}
})



-- Building Part: Stump / Axe -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_POULTRY_STUMPAXE",
	Name = "BUILDING_PART_POULTRY_STUMPAXE_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_POULTRY_STUMPAXE"
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 0.35, {0.0, 0.0}, 16 ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	},
	Cost = {
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 1 },
		}
	}
})



-- Building Part: Goose Flock -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_POULTRY_GOOSE_FLOCK",
	Name = "BUILDING_PART_POULTRY_GOOSE_FLOCK_NAME", 
	Description = "BUILDING_PART_POULTRY_GOOSE_FLOCK_DESC", 
	-- Category = "CORE", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { "PREFAB_POULTRY_CHICKEN_FLOCK" },
		MandatoryBuildingPartList = {
			{ BuildingPart = "BUILDING_PART_POULTRY_GOOSE_001" },
			{ BuildingPart = "BUILDING_PART_POULTRY_GOOSE_002" },
			{ BuildingPart = "BUILDING_PART_POULTRY_GOOSE_003" },
			{ BuildingPart = "BUILDING_PART_POULTRY_GOOSE_004" },
			{ BuildingPart = "BUILDING_PART_POULTRY_GOOSE_005" },
			{ BuildingPart = "BUILDING_PART_POULTRY_GOOSE_006" },
			{ BuildingPart = "BUILDING_PART_POULTRY_GOOSE_007" },
			{ BuildingPart = "BUILDING_PART_POULTRY_GOOSE_008" },
			{ BuildingPart = "BUILDING_PART_POULTRY_GOOSE_009" },
			{ BuildingPart = "BUILDING_PART_POULTRY_GOOSE_010" },
		}
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 2, {0.0, 0.0}, 16 ),
                Type = { DEFAULT = false, NAVIGABLE = true, GRASS_CLEAR = true } 
			}
		}
	},
	Cost = {
        BuildRightTaxes = {	{ Resource = "GOLD_COINS", Quantity = 20 } },
        -- UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 2 } }
	}
})



-- Building Part: individual Geese -------------------------------------------------------------------------------------
for i=1, 10, 1 do

    mod:register({
        DataType = "BUILDING_PART",
        Id = "BUILDING_PART_POULTRY_GOOSE_" .. string.sub("000" .. i, -3),
        Name = "BUILDING_PART_POULTRY_GOOSE_" .. string.sub("000" .. i, -3) .. "_NAME", 
        ConstructorData = {
            DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
            CoreObjectPrefab = "PREFAB_GOOSE_" .. string.sub("000" .. i, -3)
        }
    })

end



-- Building Part: One Goose (Random) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_POULTRY_GOOSE_RANDOM",
	Name = "BUILDING_PART_POULTRY_GOOSE_RANDOM_NAME", 
	Description = "BUILDING_PART_POULTRY_GOOSE_RANDOM_DESC", 
	-- Category = "CORE", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		RandomPartList = {
			"BUILDING_PART_POULTRY_GOOSE_001",
			"BUILDING_PART_POULTRY_GOOSE_002",
			"BUILDING_PART_POULTRY_GOOSE_003",
			"BUILDING_PART_POULTRY_GOOSE_004",
			"BUILDING_PART_POULTRY_GOOSE_005",
			"BUILDING_PART_POULTRY_GOOSE_006",
			"BUILDING_PART_POULTRY_GOOSE_007",
			"BUILDING_PART_POULTRY_GOOSE_008",
			"BUILDING_PART_POULTRY_GOOSE_009",
			"BUILDING_PART_POULTRY_GOOSE_010",
		}
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 0.25, {0.0, 0.0}, 4 ),
                Type = { DEFAULT = false, NAVIGABLE = true, GRASS_CLEAR = true } 
			}
		}
	},
	Cost = {
        BuildRightTaxes = {	{ Resource = "GOLD_COINS", Quantity = 2 } },
        -- UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 2 } }
	}
})



-- Building Part: Goose Pen -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_POULTRY_GOOSEPEN",
	Name = "BUILDING_PART_POULTRY_GOOSEPEN_NAME", 
	Description = "BUILDING_PART_POULTRY_GOOSEPEN_DESC", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_POULTRY_GOOSEPEN"
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {1.0, 0.1}, {1.35, 1.75} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			},
            { 
                Polygon = polygon.createRectangle( {1.0, 0.1}, {-1.35, 1.75} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			},
            { 
                Polygon = polygon.createRectangle( {3.6, 0.1}, {0.0, -1.75} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			},
            { 
                Polygon = polygon.createRectangle( {0.1, 3.6}, {1.75, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			},
            { 
                Polygon = polygon.createRectangle( {0.1, 3.6}, {-1.75, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			},
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_ASSIGNABLE_POULTRY_GOOSE",
	Cost = {
        UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 1 } },
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 4 },
		}
	}
})